diff --git a/libpurple/purpleui.h b/libpurple/purpleui.h
--- a/libpurple/purpleui.h
+++ b/libpurple/purpleui.h
@@ -26,9 +26,13 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_UI (purple_ui_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurpleUi, purple_ui, PURPLE, UI, GObject)
 
 /**
@@ -82,6 +86,7 @@ struct _PurpleUiClass {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_ui_get_id(PurpleUi *ui);
 
 /**
@@ -94,6 +99,7 @@ const char *purple_ui_get_id(PurpleUi *u
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_ui_get_name(PurpleUi *ui);
 
 /**
@@ -106,6 +112,7 @@ const char *purple_ui_get_name(PurpleUi 
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_ui_get_version(PurpleUi *ui);
 
 /**
@@ -118,6 +125,7 @@ const char *purple_ui_get_version(Purple
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_ui_get_website(PurpleUi *ui);
 
 /**
@@ -130,6 +138,7 @@ const char *purple_ui_get_website(Purple
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_ui_get_support_website(PurpleUi *ui);
 
 /**
@@ -142,6 +151,7 @@ const char *purple_ui_get_support_websit
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_ui_get_client_type(PurpleUi *ui);
 
 /**
@@ -154,6 +164,7 @@ const char *purple_ui_get_client_type(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_ui_prefs_init(PurpleUi *ui);
 
 /**
@@ -173,6 +184,7 @@ void purple_ui_prefs_init(PurpleUi *ui);
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_ui_start(PurpleUi *ui, GError **error);
 
 /**
@@ -185,6 +197,7 @@ gboolean purple_ui_start(PurpleUi *ui, G
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_ui_stop(PurpleUi *ui);
 
 /**
@@ -199,6 +212,7 @@ void purple_ui_stop(PurpleUi *ui);
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gpointer purple_ui_get_settings_backend(PurpleUi *ui);
 
 
diff --git a/libpurple/purpleversion.h b/libpurple/purpleversion.h
--- a/libpurple/purpleversion.h
+++ b/libpurple/purpleversion.h
@@ -29,6 +29,106 @@
 
 #include <glib.h>
 
+#include "purpleversionconsts.h"
+
+#if (defined(_WIN32) || defined(__CYGWIN__)) && \
+	!defined(PURPLE_STATIC_COMPILATION)
+#define _PURPLE_EXPORT __declspec(dllexport)
+#define _PURPLE_IMPORT __declspec(dllimport)
+#elif __GNUC__ >= 4
+#define _PURPLE_EXPORT __attribute__((visibility("default")))
+#define _PURPLE_IMPORT
+#else
+#define _PURPLE_EXPORT
+#define _PURPLE_IMPORT
+#endif
+#ifdef PURPLE_COMPILATION
+#define _PURPLE_API _PURPLE_EXPORT
+#else
+#define _PURPLE_API _PURPLE_IMPORT
+#endif
+
+#define _PURPLE_EXTERN _PURPLE_API extern
+
+#ifdef PURPLE_DISABLE_DEPRECATION_WARNINGS
+#define PURPLE_DEPRECATED _PURPLE_EXTERN
+#define PURPLE_DEPRECATED_FOR(f) _PURPLE_EXTERN
+#define PURPLE_UNAVAILABLE(maj, min) _PURPLE_EXTERN
+#define PURPLE_UNAVAILABLE_STATIC_INLINE(maj, min)
+#define PURPLE_UNAVAILABLE_TYPE(maj, min)
+#else
+#define PURPLE_DEPRECATED G_DEPRECATED _PURPLE_EXTERN
+#define PURPLE_DEPRECATED_FOR(f) G_DEPRECATED_FOR(f) _PURPLE_EXTERN
+#define PURPLE_UNAVAILABLE(maj, min) G_UNAVAILABLE(maj, min) _PURPLE_EXTERN
+#define PURPLE_UNAVAILABLE_STATIC_INLINE(maj, min) G_UNAVAILABLE(maj, min)
+#define PURPLE_UNAVAILABLE_TYPE(maj, min) G_UNAVAILABLE(maj, min)
+#endif
+
+/**
+ * PURPLE_VERSION_CUR_STABLE:
+ *
+ * A macro that evaluates to the current stable version of libpurple, in a format
+ * that can be used by the C pre-processor.
+ *
+ * Since: 3.0.0
+ */
+#define PURPLE_VERSION_CUR_STABLE \
+	(G_ENCODE_VERSION(PURPLE_MAJOR_VERSION, PURPLE_MINOR_VERSION))
+
+/* If the package sets PURPLE_VERSION_MIN_REQUIRED to some future
+ * PURPLE_VERSION_X_Y value that we don't know about, it will compare as 0 in
+ * preprocessor tests.
+ */
+#ifndef PURPLE_VERSION_MIN_REQUIRED
+#define PURPLE_VERSION_MIN_REQUIRED (PURPLE_VERSION_CUR_STABLE)
+#elif PURPLE_VERSION_MIN_REQUIRED == 0
+#undef PURPLE_VERSION_MIN_REQUIRED
+#define PURPLE_VERSION_MIN_REQUIRED (PURPLE_VERSION_CUR_STABLE + 1)
+#endif /* PURPLE_VERSION_MIN_REQUIRED */
+
+#if !defined(PURPLE_VERSION_MAX_ALLOWED) || (PURPLE_VERSION_MAX_ALLOWED == 0)
+#undef PURPLE_VERSION_MAX_ALLOWED
+#define PURPLE_VERSION_MAX_ALLOWED (PURPLE_VERSION_CUR_STABLE)
+#endif /* PURPLE_VERSION_MAX_ALLOWED */
+
+/* sanity checks */
+#if PURPLE_VERSION_MIN_REQUIRED > PURPLE_VERSION_CUR_STABLE
+#error "PURPLE_VERSION_MIN_REQUIRED must be <= PURPLE_VERSION_CUR_STABLE"
+#endif
+#if PURPLE_VERSION_MAX_ALLOWED < PURPLE_VERSION_MIN_REQUIRED
+#error "PURPLE_VERSION_MAX_ALLOWED must be >= PURPLE_VERSION_MIN_REQUIRED"
+#endif
+#if PURPLE_VERSION_MIN_REQUIRED < G_ENCODE_VERSION(0, 1)
+#error "PURPLE_VERSION_MIN_REQUIRED must be >= PURPLE_VERSION_0_1"
+#endif
+
+#define PURPLE_VAR _PURPLE_EXTERN
+#define PURPLE_AVAILABLE_IN_ALL _PURPLE_EXTERN
+
+/**
+ * PURPLE_VERSION_3_0:
+ *
+ * A macro that evaluates to the 3.0 version of libpurple, in a format that can
+ * be used by the C pre-processor.
+ *
+ * Since: 3.0.0
+ */
+#define PURPLE_VERSION_3_0 (G_ENCODE_VERSION(3, 0))
+
+#if PURPLE_VERSION_MAX_ALLOWED < PURPLE_VERSION_3_0
+#define PURPLE_AVAILABLE_IN_3_0 PURPLE_UNAVAILABLE(3, 0)
+#define PURPLE_AVAILABLE_STATIC_INLINE_IN_3_0 PURPLE_UNAVAILABLE_STATIC_INLINE(3, 0)
+#define PURPLE_AVAILABLE_MACRO_IN_3_0 PURPLE_UNAVAILABLE_MACRO(3, 0)
+#define PURPLE_AVAILABLE_ENUMERATOR_IN_3_0 PURPLE_UNAVAILABLE_ENUMERATOR(3, 0)
+#define PURPLE_AVAILABLE_TYPE_IN_3_0 PURPLE_UNAVAILABLE_TYPE(3, 0)
+#else
+#define PURPLE_AVAILABLE_IN_3_0 _PURPLE_EXTERN
+#define PURPLE_AVAILABLE_STATIC_INLINE_IN_3_0
+#define PURPLE_AVAILABLE_MACRO_IN_3_0
+#define PURPLE_AVAILABLE_ENUMERATOR_IN_3_0
+#define PURPLE_AVAILABLE_TYPE_IN_3_0
+#endif
+
 /**
  * PURPLE_VERSION_CHECK:
  * @major: The major version to check for.
diff --git a/libpurple/purplewhiteboard.h b/libpurple/purplewhiteboard.h
--- a/libpurple/purplewhiteboard.h
+++ b/libpurple/purplewhiteboard.h
@@ -31,6 +31,7 @@
 typedef struct _PurpleWhiteboard PurpleWhiteboard;
 
 #include "purpleaccount.h"
+#include "purpleversion.h"
 #include "purplewhiteboardops.h"
 
 /**
@@ -107,6 +108,7 @@ PurpleAccount *purple_whiteboard_get_acc
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_whiteboard_get_id(PurpleWhiteboard *whiteboard);
 
 /**
@@ -299,6 +301,7 @@ gpointer purple_whiteboard_get_protocol_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_whiteboard_equal(PurpleWhiteboard *whiteboard1, PurpleWhiteboard *whiteboard2);
 
 G_END_DECLS
diff --git a/libpurple/purplewhiteboardmanager.h b/libpurple/purplewhiteboardmanager.h
--- a/libpurple/purplewhiteboardmanager.h
+++ b/libpurple/purplewhiteboardmanager.h
@@ -26,6 +26,7 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
 #include "purplewhiteboard.h"
 
 G_BEGIN_DECLS
@@ -37,7 +38,9 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
-#define PURPLE_WHITEBOARD_MANAGER_DOMAIN (g_quark_from_static_string("purple-whiteboard-manager"))
+#define PURPLE_WHITEBOARD_MANAGER_DOMAIN \
+	g_quark_from_static_string("purple-whiteboard-manager") \
+	PURPLE_AVAILABLE_MACRO_IN_3_0
 
 #define PURPLE_TYPE_WHITEBOARD_MANAGER (purple_whiteboard_manager_get_type())
 
@@ -49,6 +52,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleWhiteboardManager, purple_whiteboard_manager,
                      PURPLE, WHITEBOARD_MANAGER, GObject)
 
@@ -61,6 +65,7 @@ G_DECLARE_FINAL_TYPE(PurpleWhiteboardMan
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleWhiteboardManager *purple_whiteboard_manager_get_default(void);
 
 /**
@@ -73,6 +78,7 @@ PurpleWhiteboardManager *purple_whiteboa
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GListModel *purple_whiteboard_manager_get_default_as_model(void);
 
 /**
@@ -88,6 +94,7 @@ GListModel *purple_whiteboard_manager_ge
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_whiteboard_manager_register(PurpleWhiteboardManager *manager, PurpleWhiteboard *whiteboard, GError **error);
 
 /**
@@ -103,6 +110,7 @@ gboolean purple_whiteboard_manager_regis
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_whiteboard_manager_unregister(PurpleWhiteboardManager *manager, PurpleWhiteboard *whiteboard, GError **error);
 
 /**
@@ -116,6 +124,7 @@ gboolean purple_whiteboard_manager_unreg
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleWhiteboard *purple_whiteboard_manager_find(PurpleWhiteboardManager *manager, const gchar *id);
 
 G_END_DECLS
diff --git a/libpurple/queuedoutputstream.h b/libpurple/queuedoutputstream.h
--- a/libpurple/queuedoutputstream.h
+++ b/libpurple/queuedoutputstream.h
@@ -25,6 +25,8 @@
 
 #include <gio/gio.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_QUEUED_OUTPUT_STREAM  purple_queued_output_stream_get_type()
@@ -48,6 +50,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleQueuedOutputStream, purple_queued_output_stream,
                      PURPLE, QUEUED_OUTPUT_STREAM, GFilterOutputStream)
 
@@ -61,6 +64,7 @@ G_DECLARE_FINAL_TYPE(PurpleQueuedOutputS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleQueuedOutputStream *purple_queued_output_stream_new(GOutputStream *base_stream);
 
 /**
@@ -82,6 +86,7 @@ PurpleQueuedOutputStream *purple_queued_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_queued_output_stream_push_bytes_async(PurpleQueuedOutputStream *stream, GBytes *bytes, int priority, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer data);
 
 /**
@@ -96,6 +101,7 @@ void purple_queued_output_stream_push_by
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_queued_output_stream_push_bytes_finish(PurpleQueuedOutputStream *stream, GAsyncResult *result, GError **error);
 
 /**
@@ -112,6 +118,7 @@ gboolean purple_queued_output_stream_pus
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_queued_output_stream_clear_queue(PurpleQueuedOutputStream *stream);
 
 G_END_DECLS
diff --git a/libpurple/request/purplerequestfield.h b/libpurple/request/purplerequestfield.h
--- a/libpurple/request/purplerequestfield.h
+++ b/libpurple/request/purplerequestfield.h
@@ -40,6 +40,7 @@
 typedef struct _PurpleRequestField PurpleRequestField;
 
 #include "purplerequestgroup.h"
+#include "purpleversion.h"
 
 /**
  * PurpleRequestFieldClass:
@@ -75,6 +76,8 @@ typedef gboolean (*PurpleRequestFieldVal
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_REQUEST_FIELD (purple_request_field_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_DERIVABLE_TYPE(PurpleRequestField, purple_request_field,
                          PURPLE, REQUEST_FIELD, GObject)
 
diff --git a/libpurple/request/purplerequestfieldaccount.h b/libpurple/request/purplerequestfieldaccount.h
--- a/libpurple/request/purplerequestfieldaccount.h
+++ b/libpurple/request/purplerequestfieldaccount.h
@@ -32,6 +32,7 @@
 
 #include "purpleaccount.h"
 #include "purplerequestfield.h"
+#include "purpleversion.h"
 
 /**
  * PurpleRequestFieldAccountFilterFunc:
@@ -47,6 +48,7 @@
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef gboolean (*PurpleRequestFieldAccountFilterFunc)(PurpleAccount *account, gpointer user_data);
 
 G_BEGIN_DECLS
@@ -59,6 +61,8 @@ G_BEGIN_DECLS
  * Since: 3.0.0
  */
 #define PURPLE_TYPE_REQUEST_FIELD_ACCOUNT (purple_request_field_account_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestFieldAccount, purple_request_field_account,
                      PURPLE, REQUEST_FIELD_ACCOUNT, PurpleRequestField)
 
@@ -165,6 +169,7 @@ gboolean purple_request_field_account_ge
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_field_account_match(PurpleRequestFieldAccount *field, PurpleAccount *account);
 
 G_END_DECLS
diff --git a/libpurple/request/purplerequestfieldbool.h b/libpurple/request/purplerequestfieldbool.h
--- a/libpurple/request/purplerequestfieldbool.h
+++ b/libpurple/request/purplerequestfieldbool.h
@@ -31,6 +31,7 @@
 #include <glib-object.h>
 
 #include "purplerequestfield.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -42,6 +43,8 @@ G_BEGIN_DECLS
  * Since: 3.0.0
  */
 #define PURPLE_TYPE_REQUEST_FIELD_BOOL (purple_request_field_bool_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestFieldBool, purple_request_field_bool,
                      PURPLE, REQUEST_FIELD_BOOL, PurpleRequestField)
 
diff --git a/libpurple/request/purplerequestfieldchoice.h b/libpurple/request/purplerequestfieldchoice.h
--- a/libpurple/request/purplerequestfieldchoice.h
+++ b/libpurple/request/purplerequestfieldchoice.h
@@ -31,6 +31,7 @@
 #include <glib-object.h>
 
 #include "purplerequestfield.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -42,6 +43,8 @@ G_BEGIN_DECLS
  * Since: 3.0.0
  */
 #define PURPLE_TYPE_REQUEST_FIELD_CHOICE (purple_request_field_choice_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestFieldChoice, purple_request_field_choice,
                      PURPLE, REQUEST_FIELD_CHOICE, PurpleRequestField)
 
diff --git a/libpurple/request/purplerequestfielddatasheet.h b/libpurple/request/purplerequestfielddatasheet.h
--- a/libpurple/request/purplerequestfielddatasheet.h
+++ b/libpurple/request/purplerequestfielddatasheet.h
@@ -32,6 +32,7 @@
 
 #include "request.h"
 #include "request-datasheet.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -43,6 +44,8 @@ G_BEGIN_DECLS
  * Since: 3.0.0
  */
 #define PURPLE_TYPE_REQUEST_FIELD_DATASHEET (purple_request_field_datasheet_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestFieldDatasheet, purple_request_field_datasheet,
                      PURPLE, REQUEST_FIELD_DATASHEET, PurpleRequestField)
 
diff --git a/libpurple/request/purplerequestfieldimage.h b/libpurple/request/purplerequestfieldimage.h
--- a/libpurple/request/purplerequestfieldimage.h
+++ b/libpurple/request/purplerequestfieldimage.h
@@ -30,6 +30,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 /**
  * PurpleRequestFieldImage:
  *
@@ -44,6 +46,8 @@ typedef struct _PurpleRequestFieldImage 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_REQUEST_FIELD_IMAGE (purple_request_field_image_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestFieldImage, purple_request_field_image,
                      PURPLE, REQUEST_FIELD_IMAGE, PurpleRequestField)
 
diff --git a/libpurple/request/purplerequestfieldint.h b/libpurple/request/purplerequestfieldint.h
--- a/libpurple/request/purplerequestfieldint.h
+++ b/libpurple/request/purplerequestfieldint.h
@@ -31,6 +31,7 @@
 #include <glib-object.h>
 
 #include "purplerequestfield.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -42,6 +43,8 @@ G_BEGIN_DECLS
  * Since: 3.0.0
  */
 #define PURPLE_TYPE_REQUEST_FIELD_INT (purple_request_field_int_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestFieldInt, purple_request_field_int,
                      PURPLE, REQUEST_FIELD_INT, PurpleRequestField)
 
diff --git a/libpurple/request/purplerequestfieldlabel.h b/libpurple/request/purplerequestfieldlabel.h
--- a/libpurple/request/purplerequestfieldlabel.h
+++ b/libpurple/request/purplerequestfieldlabel.h
@@ -31,6 +31,7 @@
 #include <glib-object.h>
 
 #include "purplerequestfield.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -42,6 +43,8 @@ G_BEGIN_DECLS
  * Since: 3.0.0
  */
 #define PURPLE_TYPE_REQUEST_FIELD_LABEL (purple_request_field_label_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestFieldLabel, purple_request_field_label,
                      PURPLE, REQUEST_FIELD_LABEL, PurpleRequestField)
 
diff --git a/libpurple/request/purplerequestfieldlist.h b/libpurple/request/purplerequestfieldlist.h
--- a/libpurple/request/purplerequestfieldlist.h
+++ b/libpurple/request/purplerequestfieldlist.h
@@ -31,6 +31,7 @@
 #include <glib-object.h>
 
 #include "purplerequestfield.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -42,6 +43,8 @@ G_BEGIN_DECLS
  * Since: 3.0.0
  */
 #define PURPLE_TYPE_REQUEST_FIELD_LIST (purple_request_field_list_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestFieldList, purple_request_field_list,
                      PURPLE, REQUEST_FIELD_LIST, PurpleRequestField)
 
diff --git a/libpurple/request/purplerequestfieldstring.h b/libpurple/request/purplerequestfieldstring.h
--- a/libpurple/request/purplerequestfieldstring.h
+++ b/libpurple/request/purplerequestfieldstring.h
@@ -31,6 +31,7 @@
 #include <glib-object.h>
 
 #include "purplerequestfield.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -42,6 +43,8 @@ G_BEGIN_DECLS
  * Since: 3.0.0
  */
 #define PURPLE_TYPE_REQUEST_FIELD_STRING (purple_request_field_string_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestFieldString, purple_request_field_string,
                      PURPLE, REQUEST_FIELD_STRING, PurpleRequestField)
 
diff --git a/libpurple/request/purplerequestgroup.h b/libpurple/request/purplerequestgroup.h
--- a/libpurple/request/purplerequestgroup.h
+++ b/libpurple/request/purplerequestgroup.h
@@ -41,8 +41,11 @@ typedef struct _PurpleRequestGroup Purpl
 
 #include "purplerequestfield.h"
 #include "purplerequestpage.h"
+#include "purpleversion.h"
 
 #define PURPLE_TYPE_REQUEST_GROUP (purple_request_group_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestGroup, purple_request_group,
                      PURPLE, REQUEST_GROUP, GObject)
 
@@ -58,6 +61,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestGroup *purple_request_group_new(const char *title);
 
 /**
@@ -69,6 +73,7 @@ PurpleRequestGroup *purple_request_group
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_request_group_add_field(PurpleRequestGroup *group, PurpleRequestField *field);
 
 /**
@@ -81,6 +86,7 @@ void purple_request_group_add_field(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_request_group_get_title(PurpleRequestGroup *group);
 
 /**
@@ -93,6 +99,7 @@ const char *purple_request_group_get_tit
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestPage *purple_request_group_get_page(PurpleRequestGroup *group);
 
 /**
@@ -105,6 +112,7 @@ PurpleRequestPage *purple_request_group_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_group_is_valid(PurpleRequestGroup *group);
 
 G_END_DECLS
diff --git a/libpurple/request/purplerequestpage.h b/libpurple/request/purplerequestpage.h
--- a/libpurple/request/purplerequestpage.h
+++ b/libpurple/request/purplerequestpage.h
@@ -42,10 +42,13 @@ typedef struct _PurpleRequestPage Purple
 #include "purpleaccount.h"
 #include "purplerequestgroup.h"
 #include "purplerequestfield.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_REQUEST_PAGE (purple_request_page_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleRequestPage, purple_request_page,
                      PURPLE, REQUEST_PAGE, GObject)
 
@@ -58,6 +61,7 @@ G_DECLARE_FINAL_TYPE(PurpleRequestPage, 
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestPage *purple_request_page_new(void);
 
 /**
@@ -69,6 +73,7 @@ PurpleRequestPage *purple_request_page_n
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_request_page_add_group(PurpleRequestPage *page, PurpleRequestGroup *group);
 
 /**
@@ -82,6 +87,7 @@ void purple_request_page_add_group(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_page_exists(PurpleRequestPage *page, const char *id);
 
 /**
@@ -95,6 +101,7 @@ gboolean purple_request_page_exists(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_page_is_field_required(PurpleRequestPage *page, const char *id);
 
 /**
@@ -107,6 +114,7 @@ gboolean purple_request_page_is_field_re
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_page_is_valid(PurpleRequestPage *page);
 
 /**
@@ -120,6 +128,7 @@ gboolean purple_request_page_is_valid(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleRequestField *purple_request_page_get_field(PurpleRequestPage *page, const char *id);
 
 /**
@@ -133,6 +142,7 @@ PurpleRequestField *purple_request_page_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_request_page_get_string(PurpleRequestPage *page, const char *id);
 
 /**
@@ -146,6 +156,7 @@ const char *purple_request_page_get_stri
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int purple_request_page_get_integer(PurpleRequestPage *page, const char *id);
 
 /**
@@ -159,6 +170,7 @@ int purple_request_page_get_integer(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_request_page_get_bool(PurpleRequestPage *page, const char *id);
 
 /**
@@ -172,6 +184,7 @@ gboolean purple_request_page_get_bool(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gpointer purple_request_page_get_choice(PurpleRequestPage *page, const char *id);
 
 /**
@@ -185,6 +198,7 @@ gpointer purple_request_page_get_choice(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *purple_request_page_get_account(PurpleRequestPage *page, const char *id);
 
 G_END_DECLS
diff --git a/libpurple/roomlist.h b/libpurple/roomlist.h
--- a/libpurple/roomlist.h
+++ b/libpurple/roomlist.h
@@ -27,6 +27,8 @@
 #ifndef PURPLE_ROOMLIST_H
 #define PURPLE_ROOMLIST_H
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_ROOMLIST (purple_roomlist_get_type())
 typedef struct _PurpleRoomlist PurpleRoomlist;
 
@@ -220,6 +222,7 @@ void purple_roomlist_cancel_get_list(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_roomlist_join_room(PurpleRoomlist *list, PurpleRoomlistRoom *room);
 
 /**************************************************************************/
diff --git a/libpurple/status.h b/libpurple/status.h
--- a/libpurple/status.h
+++ b/libpurple/status.h
@@ -27,6 +27,8 @@
 #ifndef PURPLE_STATUS_H
 #define PURPLE_STATUS_H
 
+#include "purpleversion.h"
+
 #define PURPLE_TYPE_STATUS (purple_status_get_type())
 typedef struct _PurpleStatus PurpleStatus;
 
@@ -260,6 +262,7 @@ PurpleStatusType *purple_status_type_new
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleStatusType *purple_status_type_new_with_attrsv(PurpleStatusPrimitive primitive,
                                                      const gchar *id,
                                                      const gchar *name,
@@ -519,6 +522,7 @@ void purple_status_set_active(PurpleStat
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_status_set_active_with_attributes(PurpleStatus *status, gboolean active, GHashTable *attrs);
 
 /**
@@ -731,6 +735,7 @@ void purple_statuses_uninit(void);
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GHashTable *purple_attrs_from_vargs(va_list args);
 
 G_END_DECLS
diff --git a/libpurple/util.h b/libpurple/util.h
--- a/libpurple/util.h
+++ b/libpurple/util.h
@@ -35,6 +35,7 @@
 #include "protocols.h"
 #include "purpleaccount.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -219,6 +220,7 @@ purple_strequal(const gchar *left, const
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_STATIC_INLINE_IN_3_0
 static inline gboolean
 purple_strempty(const char *str) {
 	return (str == NULL || str[0] == '\0');
@@ -347,6 +349,7 @@ void purple_str_wipe(gchar *str);
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_strmatches(const char *pattern, const char *str);
 
 /**************************************************************************/
diff --git a/libpurple/xfer.h b/libpurple/xfer.h
--- a/libpurple/xfer.h
+++ b/libpurple/xfer.h
@@ -40,6 +40,7 @@ typedef struct _PurpleXferUiOps PurpleXf
 #include "connection.h"
 #include "purpleaccount.h"
 #include "purpleprotocol.h"
+#include "purpleversion.h"
 
 /**
  * PurpleXferType:
@@ -274,6 +275,7 @@ PurpleXferStatus purple_xfer_get_status(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_xfer_get_visible(PurpleXfer *xfer);
 
 /**
@@ -455,6 +457,7 @@ void purple_xfer_set_status(PurpleXfer *
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_xfer_set_visible(PurpleXfer *xfer, gboolean visible);
 
 /**
